

#ifndef GAIMWRITE_H
#define GAIMWRITE_H


 
#define COMPLACENT 0 
#define WARY 1 
#define PARINOID 2 
#define TRUSTLEVEL  COMPLACENT 

#define G_WRITE_CONN(obj) ((GWriteConn*)obj) 
#define G_WRITE_CONV(obj) ((GWriteConv*)obj) 
#define G_WRITE_PTR_PAIR(obj) ((GWritePtrPair*)obj) 
#define G_WRITE_TO_SEND(obj) ((GWriteToSend*)obj) 

#define G_WRITE_SEND_MESSAGE     0
#define G_WRITE_REMOVE_CHANNEL   1
 
typedef struct _GWriteConn GWriteConn; 
typedef struct _GWriteConv GWriteConv; 
typedef struct _GWritePtrPair GWritePtrPair; 
typedef struct _GWriteToSend GWriteToSend;
 
struct _GWriteConn 
{ 
      SSH_SESSION* ssh_session; 
      CHANNEL* listening; 

      char locbuf[8192];
      BUFFER* ssh_buffer;
      GQueue* tosend;
      
      guint callback_handle;
}; 

struct _GWriteConv
{ 
      CHANNEL* chan; 
      guint fdhandle;
      gboolean have_recieved;
}; 

struct _GWritePtrPair
{
      void* a;
      void* b;
};

struct _GWriteToSend
{
      CHANNEL* chan;
      char* message;
      int action;
};


/*
static char* gaimwrite_read_b_channel(CHANNEL* chan);
static char* gaimwrite_clean_chars(char* c, int end);
static const char* gaimwrite_list_icon(GaimAccount *a, GaimBuddy *b);
static void gaimwrite_login(GaimAccount *account) ;
static void gaimwrite_close(GaimConnection* gc);
static void gaimwrite_add_buddy(GaimConnection *gc, GaimBuddy *buddy, 
                                GaimGroup *group);
static void gaimwrite_remove_buddy(GaimConnection *gc, GaimBuddy *buddy, 
                                   GaimGroup *group) ;
static int gaimwrite_send_im(GaimConnection *gc, const char *who, 
                             const char *message, GaimConvImFlags flags);
static void gaimwrite_close_convo(GaimConnection* gconv,const char *who);
static void gaimwrite_full_listener(gpointer data,gint source, GaimInputCondition cond);
static GList *gaimwrite_away_states(GaimConnection *gc);
static void gaimwrite_set_away(GaimConnection *gc, const char *state,
			       const char *text);
static GWriteConv* gaimwrite_get_convo(GaimConversation* gconv);
static void init_plugin(GaimPlugin *plugin);
static char* gaimwrite_read_nb_channel(CHANNEL* chan) ;
static int gaimwrite_setup_conv(GaimConnection* gc, 
                                GaimConversation* gconv, 
                                GWriteConn* conn, 
                                GWriteConv* convo, 
                                char* who, 
                                char* message);
static gboolean gaimwrite_send_message_on_channel( gpointer data) ;
*/

static const char* gaimwrite_list_icon(GaimAccount *a, GaimBuddy *b);
static void gaimwrite_login(GaimAccount *account);
static void gaimwrite_send_message(CHANNEL* chan, char* message,GaimConnection* conn) ;
static GWriteToSend* gaimwrite_new_sender(CHANNEL* chan,  char* message) ;
static GWriteToSend* gaimwrite_new_closer(CHANNEL* chan)  ;
static void gaimwrite_queue_message(GWriteConn* conn, GWriteToSend* ts) ;
static gboolean send_next_queued_message(gpointer data) ;
static void gaimwrite_full_listener(gpointer data,gint source, GaimInputCondition cond) ;
static char* gaimwrite_read_nb_channel(CHANNEL* chan,GaimConnection* gc) ;
static char* gaimwrite_clean_chars(char* c, int end) ;
static void gaimwrite_close(GaimConnection* gc) ;
static void gaimwrite_add_buddy(GaimConnection *gc, GaimBuddy *buddy, 
                                GaimGroup *group) ;
static void gaimwrite_remove_buddy(GaimConnection *gc, GaimBuddy *buddy, 
                                   GaimGroup *group) ;
static int gaimwrite_setup_conv(GaimConnection* gc, 
                                GaimConversation* gconv, 
                                GWriteConn* conn, 
                                GWriteConv* convo, 
                                char* who, 
                                char* message  ) ;
static int gaimwrite_send_im(GaimConnection *gc, const char *who, 
                             const char *message, GaimConvImFlags flags) ;
static GWriteConv* gaimwrite_get_convo(GaimConversation* gconv) ;
static void gaimwrite_close_channel(CHANNEL* chan) ;
static void gaimwrite_close_convo(GaimConnection* gconn,const char *who) ;
static GList *gaimwrite_away_states(GaimConnection *gc) ;
static void gaimwrite_set_away(GaimConnection *gc, const char *state, const char *text) ;
static void init_plugin(GaimPlugin *plugin) ;





#endif /* GAIMWRITE_H */
